Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 14777)
@@ -16,5 +16,5 @@
   }
 
-  [PushExpression(StackType.Integer, "INTEGER.FLUSH")]
+  [PushExpression(StackTypes.Integer, "INTEGER.FLUSH")]
   public class IntegerFlushExpression : FlushExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -23,5 +23,5 @@
   }
 
-  [PushExpression(StackType.Float, "FLOAT.FLUSH")]
+  [PushExpression(StackTypes.Float, "FLOAT.FLUSH")]
   public class FloatFlushExpression : FlushExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -30,5 +30,5 @@
   }
 
-  [PushExpression(StackType.Boolean, "BOOLEAN.FLUSH")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.FLUSH")]
   public class BooleanFlushExpression : FlushExpression<bool> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -37,5 +37,5 @@
   }
 
-  [PushExpression(StackType.Name, "NAME.FLUSH")]
+  [PushExpression(StackTypes.Name, "NAME.FLUSH")]
   public class NameFlushExpression : FlushExpression<string> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -44,5 +44,5 @@
   }
 
-  [PushExpression(StackType.Exec, "EXEC.FLUSH")]
+  [PushExpression(StackTypes.Exec, "EXEC.FLUSH")]
   public class ExecFlushExpression : FlushExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -51,5 +51,5 @@
   }
 
-  [PushExpression(StackType.Code, "CODE.FLUSH")]
+  [PushExpression(StackTypes.Code, "CODE.FLUSH")]
   public class CodeFlushExpression : FlushExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -57,3 +57,17 @@
     }
   }
+
+  [PushExpression(StackTypes.Char, "CHAR.FLUSH")]
+  public class CharFlushExpression : FlushExpression<char> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CharStack);
+    }
+  }
+
+  [PushExpression(StackTypes.String, "STRING.FLUSH")]
+  public class StringFlushExpression : FlushExpression<string> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.StringStack);
+    }
+  }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/IntegerExpressions.cs	(revision 14777)
@@ -10,5 +10,5 @@
   ///     Pushes the sum of the top two items.
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER.+")]
+  [PushExpression(StackTypes.Integer, "INTEGER.+")]
   public class IntegerAddExpression : PushResultExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -20,5 +20,5 @@
   ///     Pushes the difference of the top two items; that is, the second item minus the top item.
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER.-")]
+  [PushExpression(StackTypes.Integer, "INTEGER.-")]
   public class IntegerSubtractExpression : PushResultExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -30,5 +30,5 @@
   ///     Pushes the product of the top two items.
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER.*")]
+  [PushExpression(StackTypes.Integer, "INTEGER.*")]
   public class IntegerMultiplyExpression : PushResultExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -41,5 +41,5 @@
   ///     If the top item is zero this acts as a NOOP.
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER./")]
+  [PushExpression(StackTypes.Integer, "INTEGER./")]
   public class IntegerDivideExpression : PushResultExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -56,5 +56,5 @@
   ///     http://www.lispworks.com/reference/HyperSpec/Body/f_mod_r.htm.)
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER.%")]
+  [PushExpression(StackTypes.Integer, "INTEGER.%")]
   public class IntegerModuloExpression : PushResultExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -66,5 +66,5 @@
   ///     Pushes the minimum of the top two items.
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER.MIN")]
+  [PushExpression(StackTypes.Integer, "INTEGER.MIN")]
   public class IntegerMinExpression : PushResultExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -76,5 +76,5 @@
   ///     Pushes the maximum of the top two items.
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER.MAX")]
+  [PushExpression(StackTypes.Integer, "INTEGER.MAX")]
   public class IntegerMaxExpression : PushResultExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -86,5 +86,5 @@
   ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER.<")]
+  [PushExpression(StackTypes.Integer, "INTEGER.<", StackTypes.Boolean)]
   public class IntegerSmallerThanExpression : PushResultExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -96,5 +96,5 @@
   ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER.>")]
+  [PushExpression(StackTypes.Integer, "INTEGER.>", StackTypes.Boolean)]
   public class IntegerGreaterThanExpression : PushResultExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -106,5 +106,5 @@
   ///     Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER.FROMBOOLEAN")]
+  [PushExpression(StackTypes.Integer, "INTEGER.FROMBOOLEAN", StackTypes.Boolean)]
   public class IntegerFromBooleanExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -123,5 +123,5 @@
   ///     Pushes the result of truncating the top FLOAT.
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER.FROMFLOAT")]
+  [PushExpression(StackTypes.Integer, "INTEGER.FROMFLOAT", StackTypes.Float)]
   public class IntegerFromFloatExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/LoopExpression.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/LoopExpression.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/LoopExpression.cs	(revision 14777)
@@ -1,22 +1,47 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System;
 
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
 
-  public struct LoopState {
-    //public LoopState() { }
-    public LoopState(Expression body, long currentIndex, long destinationIndex, long incrementor) {
-      this.Body = body;
-      this.CurrentIndex = currentIndex;
-      this.DestinationIndex = destinationIndex;
-      this.Incrementor = incrementor;
+  [Serializable]
+  public class LoopState : IPooledObject {
+    public static LoopState Create(
+      IManagedPool<LoopState> pool,
+      Expression body,
+      long currentIndex,
+      long destinationIndex,
+      long incrementor) {
+      var state = pool.Get(false);
+
+      state.Body = body;
+      state.CurrentIndex = currentIndex;
+      state.DestinationIndex = destinationIndex;
+      state.Incrementor = incrementor;
+
+      return state;
     }
 
-    public readonly Expression Body;
-    public readonly long CurrentIndex;
-    public readonly long DestinationIndex;
-    public readonly long Incrementor;
+    public Expression Body { get; private set; }
+    public long CurrentIndex { get; private set; }
+    public long DestinationIndex { get; private set; }
+    public long Incrementor { get; private set; }
 
+    private int? hashCode;
     public override int GetHashCode() {
+      if (hashCode == null) hashCode = CalcHashCode();
+      return hashCode.Value;
+    }
+
+    public void Reset() {
+      Body = null;
+      CurrentIndex = default(long);
+      DestinationIndex = default(long);
+      Incrementor = default(long);
+    }
+
+    private int CalcHashCode() {
       var hash = 19;
 
@@ -32,4 +57,5 @@
   }
 
+  [Serializable]
   public abstract class LoopExpression : StatefulExpression<LoopState> {
     protected LoopExpression() : base(new LoopState()) { }
@@ -42,5 +68,5 @@
 
         var state = this.InitState(interpreter, sourceStack);
-        var initLoopExpression = Clone(state);
+        var initLoopExpression = Clone(state, interpreter);
 
         interpreter.ExecStack.Push(initLoopExpression, state.Body);
@@ -59,19 +85,39 @@
     }
 
+    private string stringRepresentation;
+    public override string StringRepresentation
+    {
+      get
+      {
+        if (stringRepresentation == null) {
+          var attribute = (PushExpressionAttribute)Attribute.GetCustomAttribute(GetType(), typeof(PushExpressionAttribute));
+          stringRepresentation = attribute.ExpressionName;
+        }
+
+        return stringRepresentation;
+      }
+    }
+
     protected virtual void PushIteration(IPushInterpreter interpreter) {
       interpreter.IntegerStack.Push(this.State.CurrentIndex);
 
-      var newState = new LoopState(State.Body, State.CurrentIndex + this.State.Incrementor, State.DestinationIndex, State.Incrementor);
-      var nextLoopExpression = Clone(newState);
+      var newState = LoopState.Create(
+        interpreter.PoolContainer.LoopStatePool,
+        State.Body,
+        State.CurrentIndex + State.Incrementor,
+        State.DestinationIndex,
+        State.Incrementor);
 
-      interpreter.ExecStack.Push(nextLoopExpression, this.State.Body);
+      var nextLoopExpression = Clone(newState, interpreter);
+
+      interpreter.ExecStack.Push(nextLoopExpression, State.Body);
     }
 
     protected virtual void PushLastIteration(IPushInterpreter interpreter) {
-      interpreter.IntegerStack.Push(this.State.CurrentIndex);
-      interpreter.ExecStack.Push(this.State.Body);
+      interpreter.IntegerStack.Push(State.CurrentIndex);
+      interpreter.ExecStack.Push(State.Body);
     }
 
-    protected abstract LoopExpression Clone(LoopState state);
+    protected abstract LoopExpression Clone(LoopState state, IPushInterpreter interpreter);
     protected abstract bool HasInsufficientArguments(IPushInterpreter interpreter, IStack<Expression> sourceStack);
     protected abstract LoopState InitState(IPushInterpreter interpreter, IStack<Expression> sourceStack);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/NameExpressions.cs	(revision 14777)
@@ -20,6 +20,4 @@
       return true;
     }
-
-    public override string StringRepresentation { get { return this.State; } }
   }
 
@@ -31,5 +29,5 @@
   ///     onto the NAME stack the flag will be cleared (whether or not the pushed State had a definition).
   /// </summary>
-  [PushExpression(StackType.Name, "NAME.QUOTE")]
+  [PushExpression(StackTypes.Name, "NAME.QUOTE")]
   public class NameQuoteExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -44,5 +42,5 @@
   ///     Pushes a randomly selected NAME that already has a definition.
   /// </summary>
-  [PushExpression(StackType.Name, "NAME.RANDBOUNDNAME")]
+  [PushExpression(StackTypes.Name, "NAME.RANDBOUNDNAME")]
   public class NameRandBoundNameExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 14777)
@@ -14,5 +14,5 @@
   }
 
-  [PushExpression(StackType.Integer, "INTEGER.POP")]
+  [PushExpression(StackTypes.Integer, "INTEGER.POP")]
   public class IntegerPopExpression : PopExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -21,5 +21,5 @@
   }
 
-  [PushExpression(StackType.Float, "FLOAT.POP")]
+  [PushExpression(StackTypes.Float, "FLOAT.POP")]
   public class FloatPopExpression : PopExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -28,5 +28,5 @@
   }
 
-  [PushExpression(StackType.Boolean, "BOOLEAN.POP")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.POP")]
   public class BooleanPopExpression : PopExpression<bool> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -35,5 +35,5 @@
   }
 
-  [PushExpression(StackType.Name, "NAME.POP")]
+  [PushExpression(StackTypes.Name, "NAME.POP")]
   public class NamePopExpression : PopExpression<string> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -42,5 +42,5 @@
   }
 
-  [PushExpression(StackType.Exec, "EXEC.POP")]
+  [PushExpression(StackTypes.Exec, "EXEC.POP")]
   public class ExecPopExpression : PopExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -49,5 +49,5 @@
   }
 
-  [PushExpression(StackType.Code, "CODE.POP")]
+  [PushExpression(StackTypes.Code, "CODE.POP")]
   public class CodePopExpression : PopExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -55,3 +55,17 @@
     }
   }
+
+  [PushExpression(StackTypes.Char, "CHAR.POP")]
+  public class CharPopExpression : PopExpression<char> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CharStack);
+    }
+  }
+
+  [PushExpression(StackTypes.String, "STRING.POP")]
+  public class StringPopExpression : PopExpression<string> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.StringStack);
+    }
+  }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushExpressions.cs	(revision 14777)
@@ -64,3 +64,23 @@
     }
   }
+
+  public class CharPushExpression : PushExpression<char> {
+    public CharPushExpression(char state)
+      : base(state) {
+    }
+
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CharStack);
+    }
+  }
+
+  public class StringPushExpression : PushExpression<string> {
+    public StringPushExpression(string state)
+      : base(state) {
+    }
+
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.StringStack);
+    }
+  }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 14777)
@@ -10,6 +10,16 @@
   using Interpreter;
 
+  public interface IMutablePushProgram {
+    void SetAtIndex(int index, Expression expression);
+  }
+
   [Serializable]
-  public sealed class PushProgram : Expression {
+  public sealed class PushProgram : Expression, IPooledObject, IMutablePushProgram {
+#if DEBUG
+    private const int StringRepresentationCountBeforeAggregate = 50;
+#else
+    private const int StringRepresentationCountBeforeAggregate = 10;
+#endif
+
     private static readonly Expression[] EmptyExpressions = new Expression[0];
     public static readonly PushProgram Empty = new PushProgram();
@@ -21,28 +31,26 @@
     private const string Delimiter = " ";
 
-    private Expression[] expressions;
+    private IReadOnlyList<Expression> expressions;
 
     public PushProgram() : this(EmptyExpressions) {
     }
 
-    public PushProgram(Expression[] expressions) {
+    public PushProgram(IReadOnlyList<Expression> expressions) {
       this.expressions = expressions;
     }
 
     public bool IsEmpty { get { return Count == 0; } }
-    public int Count { get { return expressions.Length; } }
+    public int Count { get { return expressions.Count; } }
 
     public IReadOnlyList<Expression> Expressions { get { return this.expressions; } }
 
-    public static PushProgram Create(IManagedPool<PushProgram> pool, params Expression[] expressions) {
+    public static PushProgram Create(IManagedPool<PushProgram> pool, IReadOnlyList<Expression> expressions) {
       var program = pool.Get();
-
       program.expressions = expressions;
-      program.Reset();
-
-      return program;
-    }
-
-    private void Reset() {
+      return program;
+    }
+
+    void IPooledObject.Reset() {
+      expressions = null;
       stringRepresentation = null;
       depth = null;
@@ -51,35 +59,39 @@
     }
 
-    public static PushProgram Merge(IManagedPool<PushProgram> pool, PushProgram first, Expression second) {
+    public static PushProgram Merge(IManagedPool<PushProgram> pool, IManagedPool<PooledList<Expression>> expressionListPool,
+      PushProgram first, Expression second) {
       var program = pool.Get();
-
-      program.Reset();
-      program.expressions = new Expression[first.Expressions.Count + 1];
-      first.CopyExpressionsTo(program.expressions);
-      program.expressions[0] = first;
-
-      return program;
-    }
-
-    public static PushProgram Merge(IManagedPool<PushProgram> pool, Expression first, PushProgram second) {
+      var list = expressionListPool.Get();
+
+      list.AddRange(first.Expressions);
+      list.Add(second);
+
+      program.expressions = list;
+
+      return program;
+    }
+
+    public static PushProgram Merge(IManagedPool<PushProgram> pool, IManagedPool<PooledList<Expression>> expressionListPool,
+      Expression first, PushProgram second) {
       var program = pool.Get();
-
-      program.Reset();
-
-      program.expressions = new Expression[second.Expressions.Count + 1];
-      program.expressions[0] = first;
-      second.CopyExpressionsTo(program.expressions, 0, 1, second.Count);
-
-      return program;
-    }
-
-    public static PushProgram Merge(IManagedPool<PushProgram> pool, PushProgram first, PushProgram second) {
+      var list = expressionListPool.Get();
+
+      list.Add(first);
+      list.AddRange(second.Expressions);
+
+      program.expressions = list;
+
+      return program;
+    }
+
+    public static PushProgram Merge(IManagedPool<PushProgram> pool, IManagedPool<PooledList<Expression>> expressionListPool,
+      PushProgram first, PushProgram second) {
       var program = pool.Get();
-
-      program.Reset();
-      program.expressions = new Expression[first.Count + second.Count];
-
-      first.CopyExpressionsTo(program.expressions);
-      second.CopyExpressionsTo(program.expressions, 0, first.Count, second.Count);
+      var list = expressionListPool.Get();
+
+      list.AddRange(first.Expressions);
+      list.AddRange(second.Expressions);
+
+      program.expressions = list;
 
       return program;
@@ -87,5 +99,10 @@
 
     public int IndexOf(Expression expression) {
-      return Array.IndexOf(this.expressions, expression);
+      var max = expressions.Count - 1;
+      for (var i = max; i >= 0; i--) {
+        if (expression.Equals(expressions[i])) return max - i;
+      }
+
+      return -1;
     }
 
@@ -127,10 +144,26 @@
     }
 
-    //public PushProgram Copy() {
-    //  // as the empty list is a static stateless expression, no copy required
-    //  return ReferenceEquals(this, Empty) || this.expressions.IsEmpty
-    //    ? Empty
-    //    : new PushProgram(this.expressions.Copy());
-    //}
+    void IMutablePushProgram.SetAtIndex(int index, Expression expression) {
+
+    }
+
+    public override bool Equals(object obj) {
+      if (ReferenceEquals(this, obj))
+        return true;
+
+      if (this.GetType() != obj.GetType())
+        return false;
+
+      var other = (PushProgram)obj;
+
+      return ReferenceEquals(expressions, other.expressions) ||
+             GetHashCode() == other.GetHashCode();
+    }
+
+    public bool Equals(PushProgram other) {
+      return ReferenceEquals(this, other) ||
+             ReferenceEquals(expressions, other.expressions) ||
+             GetHashCode() == other.GetHashCode();
+    }
 
     public override bool Eval(IPushInterpreter interpreter) {
@@ -160,10 +193,8 @@
     public IEnumerable<Expression> DepthFirst() {
       foreach (var expr in this.expressions) {
-        if (expr.IsProgram) {
-          var expandExpr = (PushProgram)expr;
-
-          foreach (var sub in expandExpr.DepthFirst())
+        if (expr.IsProgram)
+          foreach (var sub in ((PushProgram)expr).DepthFirst())
             yield return sub;
-        } else yield return expr;
+        else yield return expr;
       }
     }
@@ -172,12 +203,10 @@
       if (IsEmpty) return this;
 
-      var program = new PushProgram(this.expressions) {
-        stringRepresentation = this.stringRepresentation,
-        hashCode = this.hashCode,
-        depth = this.depth,
-        treeIndex = this.treeIndex
+      return new PushProgram(expressions) {
+        stringRepresentation = stringRepresentation,
+        hashCode = hashCode,
+        depth = depth,
+        treeIndex = treeIndex
       };
-
-      return program;
     }
 
@@ -185,6 +214,7 @@
       if (IsEmpty) return this;
 
-      var program = pool.Get();
-      program.expressions = this.expressions;
+      var program = pool.Get(reset: false);
+
+      program.expressions = expressions;
       program.stringRepresentation = stringRepresentation;
       program.hashCode = hashCode;
@@ -195,41 +225,15 @@
     }
 
-    public PushProgram Copy(IManagedPool<PushProgram> pool, int startIndex, int length) {
-      if (IsEmpty) return this;
-
-      var program = pool.Get();
-      program.expressions = CopyExpressions(startIndex, length);
-
-      program.Reset();
-
-      return program;
-    }
-
-    public Expression[] CopyExpressions() {
-      return CopyExpressions(Count);
-    }
-
-    public Expression[] CopyExpressions(int length) {
+    public IList<Expression> CopyExpressions() {
+      return new List<Expression>(this.expressions);
+    }
+
+    public IList<Expression> CopyExpressions(IManagedPool<PooledList<Expression>> expressionListPool) {
       if (IsEmpty) return EmptyExpressions;
 
-      var copy = new Expression[length];
-      this.expressions.CopyTo(copy, 0);
+      var copy = expressionListPool.Get();
+      copy.AddRange(this.expressions);
 
       return copy;
-    }
-
-    public Expression[] CopyExpressions(int startIndex, int length) {
-      if (IsEmpty) return EmptyExpressions;
-
-      var copy = new Expression[length];
-      CopyExpressionsTo(copy, startIndex, 0, length);
-
-      return copy;
-    }
-
-    public void CopyExpressionsTo(Expression[] destination, int? sourceIndex = null, int? destinationIndex = null, int? length = null) {
-      if (IsEmpty) return;
-
-      Array.Copy(this.expressions, sourceIndex ?? 0, destination, destinationIndex ?? 0, length ?? Count);
     }
 
@@ -250,7 +254,7 @@
     private string BuildString() {
       // prevent too big string
-      return this.TotalCount > 50
-        ? PrefixReduced + this.Count + PostfixReduced
-        : Prefix + string.Join(Delimiter, this.expressions.Where(e => !string.IsNullOrWhiteSpace(e.StringRepresentation))) + Postfix;
+      return TotalCount > StringRepresentationCountBeforeAggregate
+        ? PrefixReduced + Count + PostfixReduced
+        : Prefix + string.Join(Delimiter, expressions) + Postfix;
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RandExpressions.cs	(revision 14777)
@@ -8,5 +8,5 @@
   ///     Pushes a random NAME.
   /// </summary>
-  [PushExpression(StackType.Name, "NAME.RAND")]
+  [PushExpression(StackTypes.Name, "NAME.RAND")]
   public class NameRandExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -21,5 +21,5 @@
   ///     Pushes a random integer.
   /// </summary>
-  [PushExpression(StackType.Integer, "INTEGER.RAND")]
+  [PushExpression(StackTypes.Integer, "INTEGER.RAND")]
   public class IntegerRandExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -36,5 +36,5 @@
   ///     Pushes a random float.
   /// </summary>
-  [PushExpression(StackType.Float, "FLOAT.RAND")]
+  [PushExpression(StackTypes.Float, "FLOAT.RAND")]
   public class FloatRandExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -49,5 +49,5 @@
   ///     Pushes a random boolean.
   /// </summary>
-  [PushExpression(StackType.Boolean, "BOOLEAN.RAND")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.RAND")]
   public class BooleanRandExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -62,5 +62,5 @@
   ///     Pushes random expressions onto the code stack.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.RAND")]
+  [PushExpression(StackTypes.Code, "CODE.RAND")]
   public class CodeRandExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -69,6 +69,7 @@
 
       var size = (int)(interpreter.IntegerStack.Pop() % interpreter.Configuration.MaxPointsInRandomExpression);
-      var program = CodeGenerator.RandomProgram(
-        interpreter.PushProgramPool,
+      var program = LinearCodeGenerator.RandomProgram(
+        interpreter.PoolContainer.PushProgramPool,
+        interpreter.PoolContainer.ExpressionListPool,
         size,
         interpreter.Random,
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 14777)
@@ -15,5 +15,5 @@
 
 
-  [PushExpression(StackType.Integer, "INTEGER.ROT")]
+  [PushExpression(StackTypes.Integer, "INTEGER.ROT")]
   public class IntegerRotateExpression : RotateExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -22,5 +22,5 @@
   }
 
-  [PushExpression(StackType.Float, "FLOAT.ROT")]
+  [PushExpression(StackTypes.Float, "FLOAT.ROT")]
   public class FloatRotateExpression : RotateExpression<double> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -29,5 +29,5 @@
   }
 
-  [PushExpression(StackType.Boolean, "BOOLEAN.ROT")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.ROT")]
   public class BooleanRotateExpression : RotateExpression<bool> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -36,5 +36,5 @@
   }
 
-  [PushExpression(StackType.Name, "NAME.ROT")]
+  [PushExpression(StackTypes.Name, "NAME.ROT")]
   public class NameRotateExpression : RotateExpression<string> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -43,5 +43,5 @@
   }
 
-  [PushExpression(StackType.Exec, "EXEC.ROT")]
+  [PushExpression(StackTypes.Exec, "EXEC.ROT")]
   public class ExecRotateExpression : RotateExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -50,5 +50,5 @@
   }
 
-  [PushExpression(StackType.Code, "CODE.ROT")]
+  [PushExpression(StackTypes.Code, "CODE.ROT")]
   public class CodeRotateExpression : RotateExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -56,3 +56,17 @@
     }
   }
+
+  [PushExpression(StackTypes.Char, "CHAR.ROT")]
+  public class CharRotateExpression : RotateExpression<char> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.CharStack);
+    }
+  }
+
+  [PushExpression(StackTypes.String, "STRING.ROT")]
+  public class StringRotateExpression : RotateExpression<string> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(interpreter.StringStack);
+    }
+  }
 }
